(
# 1. single transfer accuracy
for qpic in 1 0; do
    for sp in 3 2; do
        python3 ./test.py -no 141 -n 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 \
                -init_prev 1 -qpic $qpic -spline $sp \
                -c "one G2P2G cycle; spline order=$sp; polypic $qpic" \
                -fn "in-paper-tests.txt" -fm t -err uv2inf \
            | tee A-$qpic-$sp.txt | ./2023-scripts/format-table.pl > A-$qpic-$sp-l.txt &
    done;
done

# 2. multiple transfers accuracy
for qpic in 1 0; do
    for sp in 3 2; do
        python3 ./test.py -no 41 -threads 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 \
                -init_prev 1 -qpic $qpic -spline $sp \
                -c "multiple xfers; spline order=$sp; polypic $qpic" \
                -fn "in-paper-tests.txt" -fm t -err uv2inf \
            | tee B-$qpic-$sp.txt | ./2023-scripts/format-table.pl > B-$qpic-$sp-l.txt &
    done;
done

# 3&4. Simulation 2d
for qpic in 1 0; do
    for sp in 3 2; do
        python3 ./test.py -no 47 -threads 0 -rf 5 -qpic $qpic -spline $sp \
                -c "force != 0; spline order=$sp; polypic $qpic" \
                -fn "in-paper-tests.txt" -fm t -err uv2inf \
            | tee C-$qpic-$sp.txt | ./2023-scripts/format-table.pl > C-$qpic-$sp-l.txt &
    done;
done

# 7. 2d TG
for mu in 0.001; do
    python3 ./test.py -no 41 -threads 0 -mu $mu -rf 5 \
            -c "TG vortex; mu=$mu; spline order=3; polypic" \
            -fn "in-paper-tests.txt" -fm t -err uv2inf \
         | tee D-$qpic-$sp.txt | ./2023-scripts/format-table.pl > D-$qpic-$sp-l.txt &
done

# 9. non-periodic (not TG) # mu!=0 but with forcing term
for mu in 0.1; do
    python3 ./test.py -no 22 -threads 0 -mu $mu -rf 5 \
            -c "Slip BC; mu=$mu; spline order=3; polypic" \
            -fn "in-paper-tests.txt" -fm t -err uv2inf \
         | tee E-$qpic-$sp.txt | ./2023-scripts/format-table.pl > E-$qpic-$sp-l.txt &
done

# 10. TG 3D
for mu in 0.1; do
    python3 ./test.py -no 46 -d 3 -dt0 0.083333333333 -dx0 16 -threads 0 -mu $mu -rf 4 \
            -c "3D TG vortex; mu=$mu; spline order=3; polypic" \
            -fn "in-paper-tests.txt" -fm t -err uv2inf \
         | tee F-$qpic-$sp.txt | ./2023-scripts/format-table.pl > F-$qpic-$sp-l.txt &
done

# 11. weird 3D
for mu in 0.1; do
    python3 ./test.py -no 47 -d 3 -dt0 0.083333333333 -dx0 16 -threads 0 -mu $mu -rf 4 \
            -c "3D weird; mu=$mu; spline order=3; polypic" \
            -fn "in-paper-tests.txt" -fm t -err uv2inf \
         | tee G-$qpic-$sp.txt | ./2023-scripts/format-table.pl > G-$qpic-$sp-l.txt &
done
wait
)
