#!/bin/bash

# Figure 1
(
./fourier_mac -order 3 -affine -polypic -o eigen-polypic.png
./fourier_mac -order 3 -affine -o eigen-apic.png
./fourier_mac -order 3 -o eigen-pic.png
) >& log-fig-1.txt

# Table 2
python3 ./test.py -no 141 -n 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 1 -spline 3 -c 'one G2P2G cycle; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-2-a.txt
python3 ./test.py -no 141 -n 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 1 -spline 2 -c 'one G2P2G cycle; spline order=2; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-2-b.txt
python3 ./test.py -no 141 -n 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 0 -spline 3 -c 'one G2P2G cycle; spline order=3; polypic 0' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-2-c.txt
python3 ./test.py -no 141 -n 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 0 -spline 2 -c 'one G2P2G cycle; spline order=2; polypic 0' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-2-d.txt

# Table 3
python3 ./test.py -no 41 -threads 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 1 -spline 3 -c 'multiple xfers; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-3-a.txt
python3 ./test.py -no 41 -threads 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 1 -spline 2 -c 'multiple xfers; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-3-b.txt
python3 ./test.py -no 41 -threads 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 0 -spline 3 -c 'multiple xfers; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-3-c.txt
python3 ./test.py -no 41 -threads 0 -adv 0 -f 0 -p 0 -mu 0 -dt0 1e-11 -rf 5 -init_prev 1 -qpic 0 -spline 2 -c 'multiple xfers; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-3-d.txt

# Table 4
python3 ./test.py -no 47 -threads 0 -rf 5 -qpic 1 -spline 3 -c 'force != 0; spline order=3; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-4-a.txt
python3 ./test.py -no 47 -threads 0 -rf 5 -qpic 1 -spline 2 -c 'force != 0; spline order=2; polypic 1' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-4-b.txt
python3 ./test.py -no 47 -threads 0 -rf 5 -qpic 0 -spline 3 -c 'force != 0; spline order=3; polypic 0' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-4-c.txt
python3 ./test.py -no 47 -threads 0 -rf 5 -qpic 0 -spline 2 -c 'force != 0; spline order=2; polypic 0' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-4-d.txt

# Table 5
python3 ./test.py -no 41 -threads 0 -mu 0.001 -rf 5 -c 'TG vortex; mu=0.001; spline order=3; polypic' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-5.txt

# Table 6
python3 ./test.py -no 22 -threads 0 -mu 0.1 -rf 5 -c 'Slip BC; mu=0.1; spline order=3; polypic' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-6.txt

# Table 7
python3 ./test.py -no 46 -d 3 -dt0 0.083333333333 -dx0 16 -threads 0 -mu 0.1 -rf 4 -c '3D TG vortex; mu=0.1; spline order=3; polypic' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-7.txt

# Table 8
python3 ./test.py -no 47 -d 3 -dt0 0.083333333333 -dx0 16 -threads 0 -mu 0.1 -rf 4 -c '3D weird; mu=0.1; spline order=3; polypic' -fn in-paper-tests.txt -fm t -err uv2inf | ./2023-scripts/format-table.pl > table-8.txt

# Figure 2
(
    cd 2023-scripts
    ./run_vorticity_inlet.sh >& log-vort-2d.txt
)

# Figure 3
(
    cd 2023-scripts
    ./run_vorticity_inlet3d.sh >& log-vort-3d.txt
)
